

angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope) {
})

.controller('NewsCtrl', function($scope, $ionicPopup, $ionicModal) {

})

.controller('HomeCtrl', function($scope, $http, $ionicLoading, Service, DMService, $cordovaDialogs, $state) {

      if(typeof analytics !== "undefined") { analytics.trackView("Home-View"); }

      $scope.switchPage = function(toPageIndex, id) {
        //switch to Training
        if(toPageIndex == 1) {
          $state.go('app.training',{trainingid:id});
        }
        //switch to Game
        else if(toPageIndex == 2) {
          $state.go('app.game',{gameid:id});
        }
        //switch to Event
        else if(toPageIndex == 3) {
          $state.go('app.event',{eventid:id});
        }
      }

      $scope.load = function () {
        $ionicLoading.show();
        Service["getHome"]()
         .success(function (data, status, headers, config) {
              $scope.newsHeader = 'News';
              $scope.termineHeader = 'nächsten ' + data.next.length + ' Termine';
              for (var i = 0; i < data.next.length; i++) {

               data.next[i] = DMService.setStatusText(data.next[i],'begin','status_id');

               data.next[i] = DMService.setCSS(data.next[i]);

               data.next[i] = DMService.setTeamName(data.next[i]);
              }
              $scope.data = data;
              console.log($scope.data);
              $ionicLoading.hide();
         })
         .error(function (data, status, headers, config) {
              $ionicLoading.hide();
              DMService.dataProblem($scope);
         })
         .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
      }

      $scope.load();
})

.controller('CalCtrl', function($scope, $ionicLoading, Service, DMService, $cordovaDialogs, $state) {
      $scope.todayArray = [];
     if(typeof analytics !== "undefined") { analytics.trackView("Cal-View"); }
     $scope.switchPage = function(toPageIndex, id) {
        //switch to Training
        if(toPageIndex == 1) {
          $state.go('app.training',{trainingid:id});
        }
        //switch to Game
        else if(toPageIndex == 2) {
          $state.go('app.game',{gameid:id});
        }
        //switch to Event
        else if(toPageIndex == 3) {
          $state.go('app.event',{eventid:id});
        }
     }

     $scope.events = [];

     $scope.sortTodayArray = function (a,b) {
      if (moment(b.date).isAfter(a.date))
         return -1;
      if (moment(a.date).isAfter(b.date))
        return 1;
      return 0;
     }

     $scope.load = function () {
      $ionicLoading.show();
      Service["getCal"]()
       .success(function (data, status, headers, config) {
            // $scope.clndr.setEvents(data);
            // $scope.$$childHead.clndr.setEvents(data);
            // $scope.clndr.setEvents(data);

            for (var i = 0; i < data.length; i++) {

              data[i] = DMService.setStatusText(data[i],'date','status_id');

              data[i] = DMService.setCSS(data[i]);

              //das könnte man durch API Anpassungen ersetzen!
              data[i] = DMService.setLabel(data[i]);

              data[i] = DMService.setTeamName(data[i]);



              //Today rausfinden
              // if(moment(data[i].date).format("YYYY-MM-DD") == moment().format("YYYY-MM-DD")) {
              if(moment(data[i].date).isSame(moment(),'day')) {
                $scope.todayArray.push(data[i]);
              }
            }

            $scope.todayArray.sort($scope.sortTodayArray);

            $scope.data = data;
            angular.element($('.clndr_container')).scope().clndr.setEvents($scope.data);

            if( sessionStorage.getItem("selectedDay") != undefined && sessionStorage.getItem("selectedDayEvents") != undefined ) {
              $(sessionStorage.getItem("selectedDay")).addClass("selected");
              $scope.currentDayEvents = JSON.parse(sessionStorage.getItem("selectedDayEvents"));
            }
            else {
              $scope.setToToday();
            }

            $ionicLoading.hide();

       })
       .error(function (data, status, headers, config) {
            $ionicLoading.hide();
            DMService.dataProblem($scope);
       });
    }

     $scope.load();

      $scope.dayClicked = function(day) {
        $(".day").removeClass("selected");
        // angular.element($('.clndr_container')).scope().clndr.setEvents($scope.data);
        $(".calendar-day-"+moment(day.date).format("YYYY-MM-DD")).addClass("selected");
        sessionStorage.setItem("selectedDay",".calendar-day-"+moment(day.date).format("YYYY-MM-DD"));
        sessionStorage.setItem("selectedDayEvents",JSON.stringify(day.events));
        // day.classes = day.classes + ' selected';
        $scope.currentDayEvents = day.events;
      }

      $scope.setToToday = function () {
        // angular.element($('.clndr_container')).scope().clndr.setMonth(moment().month());
        $(".day").removeClass("selected");
        $(".calendar-day-"+moment().format("YYYY-MM-DD")).addClass("selected");
        $scope.currentDayEvents = $scope.todayArray;
      }
})

.controller('InfoCtrl', function($scope, Service, DMService, $ionicLoading, $http, $stateParams, $cordovaDialogs) {
  if(typeof analytics !== "undefined") { analytics.trackView("Info-View"); }
    $scope.header = DMService.getTitle($stateParams.team);

    $scope.load = function () {
      $ionicLoading.show();

      Service.getInfo($stateParams.team)
        .success(function (data, status, headers, config) {
             $scope.info = data;
             $ionicLoading.hide();
        })
        .error(function (data, status, headers, config) {
             $ionicLoading.hide();
             DMService.dataProblem($scope);
        })
        .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
    }

    $scope.load();
})

.controller('GoalCtrl', function($scope, Service, DMService, $ionicLoading, $stateParams, $state, $cordovaDialogs) {
  if(typeof analytics !== "undefined") { analytics.trackView("Goal-View"); }
  $scope.header = DMService.getTitle($stateParams.team);

  $scope.load = function () {
    $ionicLoading.show();

    Service.getGoals($stateParams.team)
      .success(function (data, status, headers, config) {
        //Header für Titel einspielen
        data.header = $scope.header;
           $scope.goals = data;
           $ionicLoading.hide();
      })
      .error(function (data, status, headers, config) {
           $ionicLoading.hide();
           DMService.dataProblem($scope);
      })
      .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
  }

  $scope.load();
})

.controller('AssistCtrl', function($scope, Service, DMService, $ionicLoading, $stateParams, $state, $cordovaDialogs) {
  if(typeof analytics !== "undefined") { analytics.trackView("Assist-View"); }
    $scope.header = DMService.getTitle($stateParams.team);

  $scope.load = function () {
    $ionicLoading.show();

    Service.getAssists($stateParams.team)
      .success(function (data, status, headers, config) {
        //Header für Titel einspielen
            data.header = $scope.header;
           $scope.assists = data;
           $ionicLoading.hide();
      })
      .error(function (data, status, headers, config) {
           $ionicLoading.hide();
           DMService.dataProblem($scope);
      })
      .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
  }

  $scope.load();

})

.controller('TrainingsbeteiligungCtrl', function($scope, Service, DMService, $ionicLoading, $stateParams, $state, $cordovaDialogs) {
  if(typeof analytics !== "undefined") { analytics.trackView("Trainingsbeteiligung-View"); }
  $scope.header = DMService.getTitle($stateParams.team);

  $scope.load = function () {
    $ionicLoading.show();
    Service.getTrainingsbeteiligung($stateParams.team)
      .success(function (data, status, headers, config) {
           // var headerPart1 = data.header.substring(0,15);
           // var headerPart2 = data.header.substring(20);
           // data.header = headerPart1 + "." + headerPart2;
           //Header für Titel einspielen
           data.header = $scope.header;
           $scope.trainingsbeteiligung = data;
           $ionicLoading.hide();
      })
      .error(function (data, status, headers, config) {
           $ionicLoading.hide();
           DMService.dataProblem($scope);
      })
      .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
  };

  $scope.load();
})

.controller('GameplanCtrl', function($scope, Service, DMService, $ionicLoading, $http, $stateParams, $location, $ionicModal, $state, $ionicPopup, $anchorScroll) {
  if(typeof analytics !== "undefined") { analytics.trackView("Gameplan-View"); }

  $scope.data = {
    scrollTo: 0,
    totalItems : 0
  };

  //Header ermitteln
  $scope.header = DMService.getTitle($stateParams.team);

  $scope.switchPage = function (gameid) {
    $state.go('app.game',{gameid:gameid});
    // $location.path("#/app/game/" + gameid);
  };

  $scope.load = function () {
    $ionicLoading.show();
    // Service.getGameplan($stateParams.half, $stateParams.what, $stateParams.team)
    Service.getGameplanAll($stateParams.team)
      .success(function (data, status, headers, config) {
           $scope.gameplan = data.data;
           $scope.scrollToFound = false;
           $scope.scrollToID = 0;

           for (var i = 0; i < $scope.gameplan.length; i++) {

            $scope.gameplan[i] = DMService.setTeamName($scope.gameplan[i]);

            $scope.gameplan[i].css = 'text-color-assertive';

            $scope.gameplan[i].type = 2;
            $scope.gameplan[i] = DMService.setStatusText($scope.gameplan[i],'date','status_id');

            var isNext = DMService.isNext($scope.gameplan[i].date);

            if(!$scope.scrollToFound && isNext) {
              $scope.scrollToFound = true;
              $scope.scrollToID = $scope.gameplan[i].id;
            }
           }

           $scope.data.totalItems = $scope.gameplan.length;
           $scope.data.scrollTo = $scope.scrollToID;
           $scope.$broadcast("items-loaded");

           $ionicLoading.hide();
           // $location.hash(1017);
           // $anchorScroll();
      })
      .error(function (data, status, headers, config) {
            noInternetConnection($ionicPopup);
           $ionicLoading.hide();
           // errorCount++;
           // $scope.gamePlanError();
      })
      .finally(function() {
              // Stop the ion-refresher from spinning
              $scope.$broadcast('scroll.refreshComplete');
            });
  }

  $scope.load();

})

.controller('GameCtrl', function($scope, Service, DMService, $ionicLoading, $http, $stateParams, $state, $cordovaDialogs) {
  if(typeof analytics !== "undefined") { analytics.trackView("Game-View"); }

  $scope.load = function () {
    $ionicLoading.show();

    Service.getGame($stateParams.gameid)
    .success(function (data, status, headers, config) {
         $scope.infos = data.infos;
             //Header ermitteln
        $scope.header = DMService.getTitle($scope.infos.team_type_id);
        $scope.infos.type = 2;
        $scope.infos = DMService.setCSS($scope.infos);

        $scope.infos = DMService.setTeamName($scope.infos);
        // $scope.infos.css = 'text-color-assertive';
         // if($scope.infos.alert_msg != "" && $scope.infos.alert_msg != null && $scope.infos.alert_msg != undefined) {
         //    $scope.infos.showAlertMsg = true;
         //  }
         //  else {
         //    $scope.infos.showAlertMsg = false;
         //  }
         // $scope.infos.alert_msg = "Das Spiel wurde vom Samstag den 12.03 auf Freitag den 20.03 verschoben!";
         $scope.goals = data.goals;
         $scope.assists = data.assists;
         $ionicLoading.hide();
    })
    .error(function (data, status, headers, config) {
         $ionicLoading.hide();
         DMService.dataProblem($scope);
    })
    .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
  }

  $scope.load();
})

.controller('TrainingCtrl', function($scope, $ionicLoading, Service, DMService, $cordovaDialogs, $stateParams) {
  if(typeof analytics !== "undefined") { analytics.trackView("Training-View"); }
     $scope.load = function () {
      $ionicLoading.show();
      Service["getTraining"]($stateParams.trainingid)
       .success(function (data, status, headers, config) {
            $scope.infos = data.infos;
            $scope.infos.type = 1;
            $scope.infos = DMService.setCSS($scope.infos);
            $ionicLoading.hide();
       })
       .error(function (data, status, headers, config) {
            $ionicLoading.hide();
            DMService.dataProblem($scope);
       })
       .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
     }

     $scope.load();
})

.controller('EventCtrl', function($scope, $ionicLoading, Service, DMService, $cordovaDialogs, $stateParams) {
  if(typeof analytics !== "undefined") { analytics.trackView("Event-View"); }
     $scope.load = function () {
      $ionicLoading.show();
      Service["getEvent"]($stateParams.eventid)
       .success(function (data, status, headers, config) {
            $scope.infos = data.infos;
            $scope.infos.type = 3;
            $scope.infos = DMService.setCSS($scope.infos);
            $ionicLoading.hide();
       })
       .error(function (data, status, headers, config) {
            $ionicLoading.hide();
            DMService.dataProblem($scope);
       })
       .finally(function() {
            // Stop the ion-refresher from spinning
            $scope.$broadcast('scroll.refreshComplete');
          });
     }

     $scope.load();
})

.controller('SettingsCtrl', function($scope) {
})

.controller('HelpCtrl', function($scope, Service, DMService, $ionicLoading, $cordovaDialogs, $state) {
  $scope.data = {};
  $scope.data.name = "";
  $scope.data.email = "";
  $scope.data.text = "";
  $scope.data.device = {};

  $scope.data.device.ios = ionic.Platform.isIOS();
  $scope.data.device.android = ionic.Platform.isAndroid();
  $scope.data.device.platform = ionic.Platform.platform();
  $scope.data.device.osversion = ionic.Platform.version();
  $scope.data.device.device = ionic.Platform.device();

  $scope.alertPopup = function (buttonIndex) {
     if(buttonIndex == 1) {}
  }

  $scope.switchPage = function (buttonIndex) {
    $state.go('app.settings');
  }

  $scope.save = function () {
    if($scope.data.name != "" && $scope.data.email != "") {
      var reqData = JSON.stringify($scope.data);

      console.log(reqData);

      Service["sendSupportMessage"](reqData)
        .success(function (data, status, headers, config) {
          $ionicLoading.hide();
          DMService.openPopup({
            scope: $scope,
            callback : $scope.switchPage,
            title :'Erfolgreich',
            text : 'Nachricht wurde erfolgreich versendet!',
            buttonName : 'OK'
          });
        })
        .error(function (data, status, headers, config) {
          $ionicLoading.hide();
          DMService.dataProblem($scope);
        });
    }
    else {
      if($scope.data.name == "") {
        DMService.openPopup({
          scope: $scope,
          callback : $scope.alertPopup,
          title :'Name fehlt',
          text : 'Sie müssen einen Namen eingeben',
          buttonName : 'OK'
        });
      }
      if($scope.data.email == "") {
        DMService.openPopup({
          scope: $scope,
          callback : $scope.alertPopup,
          title :'Email fehlt',
          text : 'Sie müssen eine Adresse angeben damit wir Ihnen bei Ihrem Problem besser helfen können',
          buttonName : 'OK'
        });
      }
      if($scope.data.text == "") {
        DMService.openPopup({
          scope: $scope,
          callback : $scope.alertPopup,
          title :'Text fehlt',
          text : 'Sie müssen ein Problem angeben',
          buttonName : 'OK'
        });
      }
    }
  }


});
