angular.module('starter.directives', [])

.directive('tienClndr', function() {
  return {
    restrict: 'E',
    transclude: true,
    replace: true,
    scope: {
      clndr: '=tienClndrObject',
      events: '=tienEvents'
    },
    template: '<div><div class="clndr_container"></div></div>',
    controller: function($scope, $element, $attrs, $transclude) {
      return $transclude(function(clone, scope) {
        var render;
        $element.append(clone);
        render = function(data) {
          angular.extend(scope, data);
        };

        $scope.clndr = $($element).find(".clndr_container").clndr({
          render: render,
          daysOfTheWeek: ['Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa', 'So']
        });

        $scope.clndr.setEvents(angular.copy($scope.events));

        return $scope.clndr;
      });
    }
  };
})

.directive("delayedScroll", function($location, $ionicScrollDelegate) {

  return {
    restrict : "A",
    link : function(scope, elem, attrs) {

      console.log("ScrollTo=" + attrs.scrollTo);
      console.log("Total Items=" + attrs.totalItems);
      var monitorChildren = function() {
        return elem.children()[0].children.length;
      };

      scope.$on("items-loaded", function() {

        scope.$watch(monitorChildren, function(result) {

          console.log("Result=" + result);
          if( parseInt(result,10) == parseInt(attrs.totalItems, 10) ) {
            console.log("All elements rendered!");

            $location.hash(attrs.scrollTo);
            console.log("Scrolling to " + attrs.scrollTo);
            $ionicScrollDelegate.anchorScroll();
          }
        });

      });

    }
  }
});