angular.module('starter.services', [])

/**
 * A simple example service that returns some data.
 */
.factory('Service', function($http) {
      var baseURL = 'http://dev.rp-apps.com:8080/ufc/api/';
      // $http.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";
      return {
         getNews : function() {
            return $http.get(baseURL + 'news');
         },
         getStart : function() {
            return $http.get(baseURL + 'start');
         },
         getNext : function () {
            return $http.get(baseURL + 'next');
         },
         getInfo : function (team) {
            return $http.get(baseURL + 'info/' + team);
         },
         getTrainingsbeteiligung : function (team) {
            return $http.get(baseURL + 'trainingsbeteiligung/' + team);
         },
         getAssists : function (team) {
            return $http.get(baseURL + 'assists/' + team);
         },
         getGoals : function (team) {
            return $http.get(baseURL + 'goals/' + team);
         },
         getGameplan : function (half,what,team) {
            return $http.get(baseURL + 'gameplan/' + half + '/' + what + '/' + team);
         },
         getGameplanAll : function (team) {
            return $http.get(baseURL + 'gameplan/' + team);
         },
         getGame : function (gameid) {
            // return $http.get('http://' + macbookIP + ':8080/api/games/' + gameid);
            return $http.get(baseURL + 'games/' + gameid);
         },
         getPlayer : function (playerid) {
            return $http.get(baseURL + 'players/' + playerid);
         },
         getCal : function () {
            return $http.get(baseURL + 'cal/');
         },
         addAndroidPushId : function (id) {
            return $http.post(baseURL + 'push/' + id);
         },
         getTraining : function (trainingid) {
            return $http.get(baseURL + 'trainings/' + trainingid);
         },
         getEvent : function (eventid) {
            return $http.get(baseURL + 'events/' + eventid);
         },
         getHome : function () {
            return $http.get(baseURL + 'home/');
         },
         getTestData : function () {
            return [{"id":292,"title":"Training","date":"2014-07-01 19:00:00","time":"19:00","type":"1","info":null,"place":"Sportplatz Obritz","status_id":10},{"id":292,"title":"Training","date":"2014-07-05","time":"19:00","type":"1","info":null,"place":"Sportplatz Obritz","status_id":10}];
         },
         sendSupportMessage : function (postdata) {
            return $http.post(baseURL + 'sendSupportMessage',postdata);
         }

      }
   })

//Data - Manipulation - Service
.factory('DMService', function($cordovaDialogs) {
      return {
         isRunning : function(dateTimeFromObj) {
            var ret = false;
            dateTimeFromObj = dateTimeFromObj.replace("T"," ").replace(".000Z","");
            var momObj = moment(dateTimeFromObj);
            var momObjPlus2 = moment(dateTimeFromObj).add('hours',2);


            // if( moment().isAfter(momObj,'hour') && moment().isBefore(momObjPlus2,'hour')) {
            if( moment().isAfter(momObj) && moment().isBefore(momObjPlus2)) {
             ret = true;
            }
            return ret;
         },
         isToday : function(dateTimeFromObj) {
            var ret = false;
            dateTimeFromObj = dateTimeFromObj.replace("T"," ").replace(".000Z","");
            var momObj = moment(dateTimeFromObj);

            if( moment().isSame(momObj,'day')) {
             ret = true;
            }
            return ret;
         },
         isNext : function(dateTimeFromObj) {
            var ret = false;
            //wenn es heute ist ist die erste Bedinung des OR erfüllt und er geht rein
            //ist es nicht heute dann schaut er erst die zweite bedingung an!
            if(moment(dateTimeFromObj).isSame(moment(),'day') || moment(dateTimeFromObj).isAfter(moment(),'day')) {
             ret = true;
             console.log("is after");
            }
            return ret;
         },
         setStatusText : function(obj,dateProperty,statusProperty) {
            //heute
            var dateTimeFromObj = obj[dateProperty].replace("T"," ").replace(".000Z","");
            var momObj = moment(dateTimeFromObj);

            if( moment().isSame(momObj,'day')) {
             obj.status_text = 'HEUTE';
            }
            //läuft gerade setzen
            if(obj.type == 2) {
               var dateTimeFromObj = obj[dateProperty].replace("T"," ").replace(".000Z","");
               var momObj = moment(dateTimeFromObj);
               var momObjPlus2 = moment(dateTimeFromObj).add('hours',2);
               // if( moment().isAfter(momObj,'hour') && moment().isBefore(momObjPlus2,'hour')) {
               if( moment().isAfter(momObj) && moment().isBefore(momObjPlus2)) {
                obj.status_text = 'läuft gerade';
               }
            }

            //set Status
            if(obj[statusProperty] == 1) {
              obj.status_text = 'Abgesagt';
            }
            else if(obj[statusProperty]  == 2) {
              obj.status_text = 'Verschoben';
            }

            return obj;
         },
         setCSS : function (obj) {
            if(obj.type == 1) {
             obj.css = 'text-color-positive';
            }
            else if(obj.type == 2) {
             obj.css = 'text-color-assertive';
            }
            else if(obj.type == 3) {
             obj.css = 'text-color-energized';
            }

            return obj;
         },
         setLabel : function (obj) {
            if(obj.type == 1) {
             obj.label = 'Training';
            }
            else if(obj.type == 2) {
            }
            else if(obj.type == 3) {
             obj.label = 'Event';
            }

            return obj;
         },
         setTeamName : function (obj) {
            if(obj.home_team == 'Obritz' && obj.team_type_id == 1) {
               // obj.home_team += ' ' + obj.team_type_name;
               obj.home_team += ' KM';
            }
            else if(obj.away_team == 'Obritz' && obj.team_type_id == 1) {
               // obj.home_team += ' ' + obj.team_type_name;
               obj.away_team += ' KM';
            }

            if(obj.home_team == 'Obritz' && obj.team_type_id == 2) {
               // obj.home_team += ' ' + obj.team_type_name;
               obj.home_team += ' U23';
            }
            else if(obj.away_team == 'Obritz' && obj.team_type_id == 2) {
               // obj.home_team += ' ' + obj.team_type_name;
               obj.away_team += ' U23';
            }

            return obj;
         },
         getTitle : function (team) {
            if(team == 1) {
              return "Kampfmannschaft";
            }
            else if (team == 2) {
              return "U23";
            }
         },
         dataProblem : function ($scope) {
            $scope.alertPopup = function (buttonIndex) {
               if(buttonIndex == 1) {
               // alert("Die App wird jetzt geschlossen!");
               }
               else if (buttonIndex == 2) {
                  $scope.load();
               }
            };

            $cordovaDialogs.confirm('Leider ist ein Fehler bei der Datenübertragung passiert!',$scope.alertPopup, 'Problem', ['Abbrechen','Wiederholen']);
         },
         openPopup : function (opt) {
            $cordovaDialogs.alert(opt.text, opt.callback, opt.title, opt.buttonName);
         }
      }
   });

// .factory('PushProcessingService', function(Service) {
//         var gcmAppID = '306528130620';
//         function onDeviceReady() {
//             console.info('NOTIFY  Device is ready.  Registering with GCM server');
//             //register with google GCM server
//             var pushNotification = window.plugins.pushNotification;
//             pushNotification.register(gcmSuccessHandler, gcmErrorHandler, {"senderID":gcmAppID,"ecb":"onNotificationGCM"});
//         }
//         function gcmSuccessHandler(result) {
//             console.info('NOTIFY  pushNotification.register succeeded.  Result = '+result)
//         }
//         function gcmErrorHandler(error) {
//             console.error('NOTIFY  '+error);
//         }
//         return {
//             initialize : function () {
//                 console.info('NOTIFY  initializing');
//                 document.addEventListener('deviceready', onDeviceReady, false);
//             },
//             registerID : function (id) {
//                 //Insert code here to store the user's ID on your notification server.
//                 //You'll probably have a web service (wrapped in an Angular service of course) set up for this.
//                 //For example:
//                 // Service.registerNotificationID(id).then(function(response){
//                 Service.addAndroidPushId(id).then(function(response){
//                     // if (response.data.Result) {
//                     if(response.data){
//                         console.info('NOTIFY  Registration succeeded');
//                     } else {
//                         console.error('NOTIFY  Registration failed');
//                     }
//                 });
//             },
//             //unregister can be called from a settings area.
//             unregister : function () {
//                 console.info('unregister')
//                 var push = window.plugins.pushNotification;
//                 if (push) {
//                     push.unregister(function () {
//                         console.info('unregister success')
//                     });
//                 }
//             }
//         }
//     });
